#include <cstdio>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <iostream>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <complex>
#pragma comment(linker, "/STACK:266777216")
using namespace std;
 
typedef long long LL;
typedef unsigned long long ULL;
typedef vector<int> VI;
typedef vector<VI> VVI;
typedef pair<int,int> PII;
typedef vector<PII> VPII;
typedef vector<double> VD;
typedef pair<double,double> PDD;
 
const int inf=1000000000;
//const LL INF=LL(inf)*inf;
const double eps=1e-9;
const double PI=2*acos(0.0);
#define bit(n) (1<<(n))
#define bit64(n) ((LL(1))<<(n))
#define pb push_back
#define sz size()
#define mp make_pair
#define cl clear()
#define all(a) (a).begin(),(a).end()
#define fill(ar,val) memset((ar),(val),sizeof (ar))
#define MIN(a,b) {if((a)>(b)) (a)=(b);}
#define MAX(a,b) {if((a)<(b)) (a)=(b);}
#define min(a,b) ((a)<(b)?(a):(b))
#define max(a,b) ((a)>(b)?(a):(b))
#define sqr(x) ((x)*(x))
#define X first
#define Y second
 
//clock_t start=clock();
//fprintf(stderr,"time=%.3lfsec\n",0.001*(clock()-start));
 
const int maxN = 100000;
const int maxS = 100000;
const int maxH = 17;
const int maxK = 1000000000;
 
int bitlen[maxN+2];
 
void check(const string &s)
{
	int L=s.sz;
	assert(1<=L && L<=maxS);
	for(int i=0;i<L;i++)
		assert(s[i]=='4' || s[i]=='7' || s[i]=='?');
}
 
struct data
{
	int n;
	VI l4,r7;
	VI L4,R7;
	VI rmq[maxH];
 
	void init()
	{
		string s;
		cin >> s;
		check(s);
		n=s.sz;
		VI c4(n+1,0),c7(n+1,0);
		VI C4(n+1,0),C7(n+1,0);
		int i;
		for(i=0;i<n;i++)
		{
			c4[i+1]=c4[i]+(s[i]=='4');
			C4[i+1]=C4[i]+(s[i]!='7');
		}
		for(i=n;i--;)
		{
			c7[i]=c7[i+1]+(s[i]=='7');
			C7[i]=C7[i+1]+(s[i]!='4');
		}
		L4=l4=VI(n+1,n+1);
		for(i=n;i>=0;i--)
		{
			L4[C4[i]]=i;
			l4[c4[i]]=i;
		}
		R7=r7=VI(n+1,-1);
		for(i=0;i<=n;i++)
		{
			R7[C7[i]]=i;
			r7[c7[i]]=i;
		}
		rmq[0]=VI(n+1);
		for(i=0;i<=n;i++) rmq[0][i]=c4[i]+c7[i];
		for(int h=0;bit(h+1)<=n+1;h++)
		{
			rmq[h+1]=VI(n+1);
			for(i=0;i+bit(h+1)<=n+1;i++)
				rmq[h+1][i]=max(rmq[h][i],rmq[h][i+bit(h)]);
		}
	}
	int query(int n4,int n7)
	{
		int L=L4[n4],R=R7[n7];
		if(L>R) return maxK+1;
		int l=l4[n4],r=r7[n7];
		if(l<=r) return 0;
		MAX(L,r);
		MIN(R,l);
		int h=bitlen[R-L+1];
		int ans=n4+n7-max(rmq[h][L],rmq[h][R-bit(h)+1]);
		return max(ans,0);
	}
};
 
vector<data> a;
 
int main()
{
#ifndef ONLINE_JUDGE
	//freopen("in.txt","rb",stdin);
	freopen("0.in","rb",stdin);
	freopen("0_my.out","w",stdout);
#endif
	for(int h=0;h<maxH;h++)
		for(int i=bit(h);i<maxN+2 && i<bit(h+1);i++)
			bitlen[i]=h;
	int n,k;
	scanf("%d%d",&n,&k);
	assert(1<=n && n<=maxN);
	assert(0<=k && k<=maxK);
	vector<data> a(n);
	int totL=0;
	int minL=maxS+1;
	for(int i=0;i<n;i++)
	{
		a[i].init();
		totL+=a[i].n;
		MIN(minL,a[i].n);
	}
	assert(totL<=maxS);
	int L=0,R=minL+1;
	int ans4=0,ans7=0;
	while(L+1<R)
	{
		int M=(L+R)/2;
		int n4;
		for(n4=M;n4>=0;n4--)
		{
			int n7=M-n4;
			int totk=0;
			for(int i=0;i<n;i++)
			{
				totk+=a[i].query(n4,n7);
				if(totk>k) break;
			}
			if(totk<=k) break;
		}
		if(n4<0) R=M; else
		{
			ans4=n4;
			ans7=M-n4;
			L=M;
		}
	}
	cout << string(ans4,'4')+string(ans7,'7') << endl;
	{char c; assert(!(cin >> c));}
	return 0;
}
  
